diff --git a/src/backend/optimizer/plan/initsplan.c b/src/backend/optimizer/plan/initsplan.c
new file mode 100644
index 6ceb801..6712f8f
*** a/src/backend/optimizer/plan/initsplan.c
--- b/src/backend/optimizer/plan/initsplan.c
***************
*** 14,20 ****
--- 14,25 ----
   */
  #include "postgres.h"
  
+ #include "access/htup_details.h"
+ #include "access/sysattr.h"
+ #include "catalog/pg_aggregate.h"
+ #include "catalog/pg_operator.h"
  #include "catalog/pg_type.h"
+ #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
  #include "optimizer/clauses.h"
  #include "optimizer/cost.h"
***************
*** 26,35 ****
--- 31,42 ----
  #include "optimizer/planner.h"
  #include "optimizer/prep.h"
  #include "optimizer/restrictinfo.h"
+ #include "optimizer/tlist.h"
  #include "optimizer/var.h"
  #include "parser/analyze.h"
  #include "rewrite/rewriteManip.h"
  #include "utils/lsyscache.h"
+ #include "utils/syscache.h"
  
  
  /* These parameters are set by GUC */
*************** static List *deconstruct_recurse(Planner
*** 51,56 ****
--- 58,67 ----
  					bool below_outer_join,
  					Relids *qualscope, Relids *inner_join_rels,
  					List **postponed_qual_list);
+ static void build_base_rel_tlist_grouped(PlannerInfo *root, RelOptInfo *rel,
+ 										 List *aggregates, Aggref  *countagg,
+ 										 List **countagg_vars);
+ static void finalize_grouped_vars(PlannerInfo *root, List *countagg_vars);
  static SpecialJoinInfo *make_outerjoininfo(PlannerInfo *root,
  				   Relids left_rels, Relids right_rels,
  				   Relids inner_join_rels,
*************** add_vars_to_targetlist(PlannerInfo *root
*** 236,241 ****
--- 247,861 ----
  	}
  }
  
+ /*
+  * Initialize rel->reltarget_grouped where possible.
+  *
+  * root->group_pathkeys must be setup before this function is called.
+  */
+ extern void
+ build_base_rel_tlists_grouped(PlannerInfo *root)
+ {
+ 	List	   *tlist_vars;
+ 	List		*aggregates = NIL;
+ 	ListCell	*lc;
+ 	bool		aggs_acceptable = true;
+ 	Aggref		*countagg = NULL;
+ 	List		*countagg_vars = NIL;
+ 	int			nbaserels = 0;
+ 	int			i;
+ 
+ 	/* No grouping in the query? */
+ 	if (!root->parse->groupClause || root->group_pathkeys == NIL)
+ 		return;
+ 
+ 	/* TODO This is just for PoC. Relax the limitation later. */
+ 	if (root->parse->havingQual)
+ 		return;
+ 
+ 	/*
+ 	 * If no join is expected, aggregation at base relation level makes no
+ 	 * sense. XXX Is there simpler way to find out? (We're not interested in
+ 	 * RELOPT_OTHER_MEMBER_REL, so simple_rel_array_size does not help.)
+ 	 */
+ 	for (i = 1; i < root->simple_rel_array_size; i++)
+ 	{
+ 		RelOptInfo *rel;
+ 
+ 		rel = find_base_rel(root, i);
+ 		if (rel->reloptkind == RELOPT_BASEREL)
+ 		{
+ 			nbaserels++;
+ 			/*
+ 			 * We only want to know whether the number of relations is greater
+ 			 * than one.
+ 			 */
+ 			if (nbaserels > 1)
+ 				break;
+ 		}
+ 	}
+ 	if (nbaserels <= 1)
+ 		return;
+ 
+ 	tlist_vars = pull_var_clause((Node *) root->processed_tlist,
+ 								 PVC_INCLUDE_AGGREGATES);
+ 	if (tlist_vars == NIL)
+ 		return;
+ 
+ 	/* tlist_vars may also contain Vars, but we only need Aggrefs. */
+ 	foreach(lc, tlist_vars)
+ 	{
+ 		Expr *expr = (Expr *) lfirst(lc);
+ 
+ 		if (!IsA(expr, Var))
+ 		{
+ 			Aggref	*aggref = (Aggref *) expr;
+ 
+ 			Assert(IsA(aggref, Aggref));
+ 
+ 			/* TODO Think if (some of) these can be handled. */
+ 			if (aggref->aggstar || aggref->aggvariadic || aggref->aggdirectargs ||
+ 				aggref->aggorder || aggref->aggdistinct || aggref->aggfilter)
+ 			{
+ 				aggs_acceptable = false;
+ 				break;
+ 			}
+ 
+ 			aggregates = lappend(aggregates, expr);
+ 		}
+ 	}
+ 
+ 	if (aggregates != NIL && aggs_acceptable)
+ 	{
+ 		int	i;
+ 
+ 		if (countagg == NULL)
+ 		{
+ 			/* count(*) aggregate for base relation grouping. */
+ 			countagg = makeNode(Aggref);
+ 			countagg->aggfnoid = COUNTFNOID;
+ 			countagg->aggkind = AGGKIND_NORMAL;
+ 			countagg->aggtype = INT8OID;
+ 			countagg->aggtranstype = INT8OID;
+ 			countagg->aggstar = true;
+ 		}
+ 		/* Process the individual base relations. */
+ 		root->all_baserels_grouped = true;
+ 		for (i = 1; i < root->simple_rel_array_size; i++)
+ 		{
+ 			RelOptInfo	*rel;
+ 
+ 			rel = root->simple_rel_array[i];
+ 			if (rel != NULL)
+ 				build_base_rel_tlist_grouped(root, rel, aggregates, countagg,
+ 											 &countagg_vars);
+ 
+ 			/*
+ 			 * Don't bother processing the rest if the current rel prevents us
+ 			 * from forming the final "grouped join".
+ 			 */
+ 			if (!root->all_baserels_grouped)
+ 				break;
+ 		}
+ 
+ 		if (root->all_baserels_grouped)
+ 			finalize_grouped_vars(root, countagg_vars);
+ 	}
+ 	else
+ 		root->all_baserels_grouped = false;
+ 
+ 	if (aggregates != NIL)
+ 		list_free(aggregates);
+ 	list_free(tlist_vars);
+ }
+ 
+ /*
+  * Construct target of grouped relation - that can only contain grouping
+  * expressions and aggregates. Such a target can't be created if anything else
+  * is required on the output.
+  *
+  * countagg represents count(*) aggregate that each grouped rel must have to
+  * collect information of per-group row count. This information is used to
+  * adjust the transient state in the output of the final join.
+  *
+  * Variable representing the result of countagg is added to *countagg_vars
+  * list (besides being added to root->grouped_var_list as well, so that it the
+  * actual count(*) expression be restored by set_upper_references.)
+  */
+ static void
+ build_base_rel_tlist_grouped(PlannerInfo *root, RelOptInfo *rel,
+ 							 List *aggregates, Aggref  *countagg,
+ 							 List **countagg_vars)
+ {
+ 	RangeTblEntry *rte;
+ 	List		*rel_aggregates;
+ 	ListCell	*lc;
+ 	Relids	agg_arg_rels_all, agg_arg_attrs_all;
+ 	PathTarget	*reltarget_grouped;
+ 	bool		first;
+ 
+ 	rte = root->simple_rte_array[rel->relid];
+ 
+ 	/*
+ 	 * XXX Append relation, as well as rtekind != RTE_RELATION seem to deserve
+ 	 * separate patches.
+ 	 */
+ 	if (rel->reloptkind == RELOPT_OTHER_MEMBER_REL ||
+ 		rte->rtekind != RTE_RELATION)
+ 	{
+ 		root->all_baserels_grouped = false;
+ 		return;
+ 	}
+ 
+ 	/* Caller should only pass elements of root->simple_rel_array. */
+ 	Assert(rel->reloptkind == RELOPT_BASEREL);
+ 	Assert(bms_membership(rel->relids) == BMS_SINGLETON);
+ 
+ 	/*
+ 	 * If any outer join can set the attribute value to NULL, the aggregate
+ 	 * would receive different input at the base rel level.
+ 	 *
+ 	 * TODO This as well as some other limitations below should only apply to
+ 	 * the PoC version of the patch. In the future we should handle
+ 	 * non-grouped relations by joining them to the grouped ones and applying
+ 	 * additional partial aggregation to the final join.
+ 	 */
+ 	if (bms_overlap(rel->relids, root->nullable_baserels))
+ 	{
+ 		root->all_baserels_grouped = false;
+ 		return;
+ 	}
+ 
+ 	/* Collect aggregates applicable to the current relation. */
+ 	rel_aggregates = NIL;
+ 	agg_arg_rels_all = NULL;
+ 	agg_arg_attrs_all = NULL;
+ 	foreach(lc, aggregates)
+ 	{
+ 		Aggref	*aggref = (Aggref *) lfirst(lc);
+ 		Relids	agg_arg_rels, agg_arg_attrs = NULL;
+ 
+ 		/* TODO Does it matter if any argument contains PHV ? */
+ 		agg_arg_rels = pull_varnos((Node *) aggref->args);
+ 
+ 		/* Skip aggregates which don't reference rel at all. */
+ 		if (!bms_overlap(rel->relids, agg_arg_rels))
+ 			continue;
+ 
+ 		/*
+ 		 * If the aggregate references multiple rels, it must be processed
+ 		 * higher in the join tree.
+ 		 */
+ 		if (bms_membership(agg_arg_rels) != BMS_SINGLETON)
+ 		{
+ 			/*
+ 			 * TODO Consider relaxing this limitation by adding one extra
+ 			 * partial aggregation below the final one.
+ 			 */
+ 			root->all_baserels_grouped = false;
+ 
+ 			return;
+ 		}
+ 
+ 		/* Accept this aggregate. */
+ 		rel_aggregates = lappend(rel_aggregates, aggref);
+ 		agg_arg_rels_all = bms_union(agg_arg_rels_all, agg_arg_rels);
+ 
+ 		/* Collect attnos while being here. */
+ 		pull_varattnos((Node *) aggref->args, rel->relid, &agg_arg_attrs);
+ 		agg_arg_attrs_all = bms_union(agg_arg_attrs_all, agg_arg_attrs);
+ 	}
+ 
+ 	Assert(rel->reltarget_grouped == NULL);
+ 
+ 	/*
+ 	 * Create a separate target which represents the actual output of grouped
+ 	 * relation. This target will have aggregates replaced with special vars
+ 	 * which will ensure propagation of the result of the partial aggregation
+ 	 * of the base relation to the final Agg node.
+ 	 *
+ 	 * This target won't contain expressions that the grouped relation cannot
+ 	 * emit. Another difference from rel->reltarget is that sortgroupref is
+ 	 * set for each grouping expression. This is because the same target will
+ 	 * be used for the partial aggregation.
+ 	 *
+ 	 * (Do not set rel->reltarget_grouped yet, as we might return
+ 	 * prematurely.)
+ 	 */
+ 	reltarget_grouped = create_empty_pathtarget();
+ 
+ 	/*
+ 	 * Check if all the output columns can be used as grouping expressions.
+ 	 *
+ 	 * TODO
+ 	 *
+ 	 * 1. How about PHVs?
+ 	 *
+ 	 * 2. Consider additional grouping expressions, just to be able to emit
+ 	 * the columns that the query group clause doesn't mention. (These
+ 	 * additional expressions wouldn't be used during the final aggregation.)
+ 	 * Does this also mean that we shouldn't check existence of
+ 	 * parse->groupClause earlier in this function?
+ 	 */
+ 	foreach(lc, rel->reltarget->exprs)
+ 	{
+ 		ListCell	*lc2;
+ 		Expr		*texpr = (Expr *) lfirst(lc);
+ 		bool		is_grouping = false;
+ 		bool		ec_found = false;
+ 		bool		agg_arg_only = false;
+ 
+ 		/*
+ 		 * First, check if the query group clause contains exactly this
+ 		 * expression.
+ 		 */
+ 		foreach(lc2, root->processed_tlist)
+ 		{
+ 			TargetEntry		*te = (TargetEntry *) lfirst(lc2);
+ 
+ 			Assert(IsA(te, TargetEntry));
+ 
+ 			if (equal(texpr, te->expr) && te->ressortgroupref > 0)
+ 			{
+ 				add_column_to_pathtarget(reltarget_grouped, texpr,
+ 										 te->ressortgroupref);
+ 				is_grouping = true;
+ 				break;
+ 			}
+ 		}
+ 
+ 		/* Go for the next expression if matched the current one. */
+ 		if (is_grouping)
+ 			continue;
+ 
+ 		/*
+ 		 * If exactly this expression is not there, check if a grouping clause
+ 		 * exists that belongs to the same equivalence class as the
+ 		 * expression.
+ 		 */
+ 		foreach(lc2, root->group_pathkeys)
+ 		{
+ 			PathKey	*pk = (PathKey *) lfirst(lc2);
+ 			EquivalenceClass		*ec = pk->pk_eclass;
+ 			ListCell		*lm;
+ 			EquivalenceMember		*em;
+ 			Expr	*em_expr = NULL;
+ 			Query	*query = root->parse;
+ 			Index	sortgroupref;
+ 
+ 			/*
+ 			 * Single-member EC cannot provide us with additional
+ 			 * expression.
+ 			 */
+ 			if (list_length(ec->ec_members) < 2)
+ 				continue;
+ 
+ 			/* We need equality anywhere in the join tree. */
+ 			if (ec->ec_below_outer_join)
+ 				continue;
+ 
+ 			/*
+ 			 * TODO Reconsider this restriction. As the grouping expression is
+ 			 * only evaluated at the relation level (and only the result will
+ 			 * be propagated to the final targetlist), volatile function might
+ 			 * be o.k. Need to think what volatile EC exactly means.
+ 			 */
+ 			if (ec->ec_has_volatile)
+ 				continue;
+ 
+ 			foreach(lm, ec->ec_members)
+ 			{
+ 				em = (EquivalenceMember *) lfirst(lm);
+ 
+ 				/* The EC has !ec_below_outer_join. */
+ 				Assert(!em->em_nullable_relids);
+ 				if (equal(em->em_expr, texpr))
+ 				{
+ 					em_expr = (Expr *) em->em_expr;
+ 					break;
+ 				}
+ 			}
+ 
+ 			if (em_expr == NULL)
+ 				/* Go for the next EC. */
+ 				continue;
+ 
+ 			/*
+ 			 * Find the corresponding SortGroupClause, which provides us
+ 			 * with sortgroupref. (It can belong to any EC member.)
+ 			 */
+ 			sortgroupref = 0;
+ 			foreach(lm, ec->ec_members)
+ 			{
+ 				ListCell	*lsg;
+ 
+ 				em = (EquivalenceMember *) lfirst(lm);
+ 				foreach(lsg, query->groupClause)
+ 				{
+ 					SortGroupClause	*sgc;
+ 					Expr	*texpr;
+ 
+ 					sgc = (SortGroupClause *) lfirst(lsg);
+ 					texpr = (Expr *) get_sortgroupclause_expr(sgc,
+ 															  query->targetList);
+ 					if (equal(em->em_expr, texpr))
+ 					{
+ 						Assert(sgc->tleSortGroupRef > 0);
+ 						sortgroupref = sgc->tleSortGroupRef;
+ 						break;
+ 					}
+ 				}
+ 
+ 				if (sortgroupref > 0)
+ 					break;
+ 			}
+ 
+ 			/*
+ 			 * At least one EM of this EC should have correspond to a
+ 			 * SortGroupClause, otherwise the EC could hardly exist.
+ 			 */
+ 			if (sortgroupref == 0)
+ 				elog(ERROR, "Grouping EC does not match any grouping clause.");
+ 
+ 			/* It's o.k. to use the target expression for grouping. */
+ 			add_column_to_pathtarget(reltarget_grouped, texpr, sortgroupref);
+ 			ec_found = true;
+ 			break;
+ 		}
+ 
+ 		/*
+ 		 * It may still be o.k. if the expression is only contained in Aggref
+ 		 * - then it's not expected in the grouped output.
+ 		 *
+ 		 * TODO Try to handle generic expression, not only Var. That might
+ 		 * require us to create rel->reltarget of the grouping rel in
+ 		 * parallel to that of the plain rel, and adding whole expressions
+ 		 * instead of individual vars.
+ 		 */
+ 		if (IsA(texpr, Var) &&
+ 			bms_is_member(((Var *) texpr)->varattno -
+ 						  FirstLowInvalidHeapAttributeNumber, agg_arg_attrs_all))
+ 			agg_arg_only = true;
+ 
+ 		/*
+ 		 * A single mismatched expression makes the whole relation useless
+ 		 * for grouping at base level.
+ 		 */
+ 		if (!ec_found && !agg_arg_only)
+ 			return;
+ 	}
+ 
+ 	/*
+ 	 * Add the count(*) aggregate, as its processing is nearly identical to
+ 	 * that of other aggregates. It should be located in front of the other
+ 	 * vars so they can reference it.
+ 	 *
+ 	 * TODO Avoid this if no aggregate in the query has aggtransmultifn.
+ 	 */
+ 	rel_aggregates = lcons(countagg, rel_aggregates);
+ 
+ 	/*
+ 	 * Add each aggregate to reltarget_grouped in the form of special
+ 	 * variable, for which GroupedVarInfo will also be added to
+ 	 * root->grouped_var_list.
+ 	 *
+ 	 * It doesn't matter that the relation contains no such variables - they
+ 	 * will be replaced with the partially-aggregated Aggref before execution
+ 	 * starts - see restore_grouped_var_expr.
+ 	 */
+ 	first = true;
+ 	foreach(lc, rel_aggregates)
+ 	{
+ 		Aggref	*aggref = (Aggref *) lfirst(lc);
+ 		AttrNumber	varattno;
+ 		Var		*var;
+ 		GroupedVarInfo	*gvi;
+ 
+ 		rel->max_attr++;
+ 		varattno = rel->max_attr;
+ 
+ 		var = makeVar(rel->relid, varattno, InvalidOid, 0, InvalidOid, 0);
+ 		add_new_column_to_pathtarget(reltarget_grouped, (Expr *) var);
+ 
+ 		/*
+ 		 * Create writable copy so that it can be marked as partial, and
+ 		 * eventually be associated with the final aggregate - see
+ 		 * set_upper_references. (XXX Is copy necessary for the count(*)
+ 		 * aggregate as well?)
+ 		 */
+ 		aggref = copyObject(aggref);
+ 
+ 		if (first)
+ 		{
+ 			/* count(*) should be the first item of the list. */
+ 			Assert(aggref->aggfnoid == COUNTFNOID && aggref->aggstar);
+ 
+ 			/*
+ 			 * The variable representing the auxiliary count(*) is not subject
+ 			 * to the final aggregation (in fact the result is used as
+ 			 * argument of aggtransmultifn, which prepares input value for the
+ 			 * final aggregationq), so there's never reason to restore the
+ 			 * count(*) expression. Moreover, restoration of the count(*)
+ 			 * expression outside Aggref (e.g. in the targetlist of the final
+ 			 * join) would cause ERROR during plan initialization.
+ 			 *
+ 			 * So instead of creating GroupedVarInfo we only add the var to a
+ 			 * list of vars that GroupedVarInfo.expr_intermediate can
+ 			 * reference.
+ 			 */
+ 			*countagg_vars = lappend(*countagg_vars, var);
+ 
+ 			first = false;
+ 		}
+ 
+ 		/*
+ 		 * Associate the expression with the corresponding variable, so that
+ 		 * set_upper_references can do the changes explained above.
+ 		 */
+ 		gvi = (GroupedVarInfo *) palloc0(sizeof(GroupedVarInfo));
+ 		gvi->var = var;
+ 
+ 		/* The variable represents result of the partial aggregation. */
+ 		mark_partial_aggref(aggref, AGGSPLIT_INITIAL_SERIAL);
+ 		/* The variable type info should reflect the transient type. */
+ 		var->vartype = exprType((Node *) aggref);
+ 		var->vartypmod = exprTypmod((Node *) aggref);
+ 		var->varcollid = exprCollation((Node *) aggref);
+ 
+ 		gvi->expr = (Expr *) aggref;
+ 		gvi->sortgroupref = 0;
+ 		root->grouped_var_list = lappend(root->grouped_var_list, gvi);
+ 
+ 		/*
+ 		 * Add the variable to rel->attr_needed to ensure propagation to the
+ 		 * top-level target list. (Non-grouped path are not aware of the
+ 		 * variable, and they should already be generated by now.)
+ 		 */
+ 		rel->attr_needed = (Relids *)
+ 			repalloc(rel->attr_needed, (rel->max_attr - rel->min_attr + 1) *
+ 					 sizeof(Relids));
+ 		rel->attr_needed[varattno - rel->min_attr] = bms_make_singleton(0);
+ 
+ 		/*
+ 		 * As set_rel_width should already have completed, it makes no sense
+ 		 * to add the variable to attr_widths. Instead we only adjust
+ 		 * rel->reltarget->width.
+ 		 */
+ 		/* TODO Adjust rel->reltarget->width */
+ 	}
+ 
+ 	rel->reltarget_grouped = reltarget_grouped;
+ }
+ 
+ /*
+  *  Initialize expr_intermediate of each GroupedVarInfo that requires it.
+  *  This expression will adjust partial state of an aggregate prior to final
+  *  aggregation, so it reflects existence of joins.
+  *
+  *  If a single relation is aggregated, only the table determines how many
+  *  times each value of aggregate argument appears in the relevant group. But
+  *  if relation is joined to another one, the aggregate executed on the final
+  *  join (i.e. w/o the relation-level aggregation) can actually receive the
+  *  whole input set multiple times: some values of the grouping key present in
+  *  the relation can match multiple values in the other table(s).
+  *
+  *  sum() is an example of an aggregate where join matters, avg() is one where
+  *  it does not.
+  *
+  *  We simulate the effect of joins by applying aggtransmultifn (see
+  *  pg_aggregate) to the result of relation-level aggregation.
+  */
+ static void
+ finalize_grouped_vars(PlannerInfo *root, List *countagg_vars)
+ {
+ 	ListCell	*lc;
+ 	Oid			op_int8mul = InvalidOid;
+ 
+ 	foreach(lc, root->grouped_var_list)
+ 	{
+ 		GroupedVarInfo	*gvi = (GroupedVarInfo *) lfirst(lc);
+ 		Aggref	*aggref = (Aggref *) gvi->expr;
+ 		ListCell	*l;
+ 		Expr	*factor = NULL;
+ 
+ 		Assert(gvi->expr_intermediate == NULL);
+ 		Assert(IsA(aggref, Aggref));
+ 
+ 		/* Is transient state multiplication needed for this aggregate? */
+ 		if (aggref->aggtransmultifn == InvalidOid)
+ 			continue;
+ 
+ 		/*
+ 		 * If there was no relation-level aggregation, each table joined to
+ 		 * the one gvi->varno points at would increase the frequency of a
+ 		 * value within a group by the factor which equals to the frequency of
+ 		 * the corresponding grouping key in the table joined.
+ 		 *
+ 		 * To prepare the correct input for the final aggregation, the
+ 		 * relation-level per-group state must be "multiplied" by the number
+ 		 * of grouping key values that join of the *other* tables (i.e. all
+ 		 * but the one referenced by the current aggregate) generates.
+ 		 *
+ 		 * This is why count(*) was added to each base relation.
+ 		 */
+ 		foreach(l, countagg_vars)
+ 		{
+ 			Var *var = (Var *) lfirst(l);
+ 
+ 			/* Only the other tables do matter. */
+ 			if (var->varno == gvi->var->varno)
+ 				continue;
+ 
+ 			if (factor == NULL)
+ 				/* The first value. */
+ 				factor = (Expr *) var;
+ 			else
+ 			{
+ 				OpExpr	*op = makeNode(OpExpr);
+ 
+ 				/*
+ 				 * Multiply the intermediate result by the result of the next
+ 				 * count(*) aggregate.
+ 				 */
+ 				op->opno = OPERATOR_INT8MUL;
+ 				if (op_int8mul == InvalidOid)
+ 				{
+ 					set_opfuncid(op);
+ 					op_int8mul = op->opfuncid;
+ 				}
+ 				else
+ 					op->opfuncid = op_int8mul;
+ 
+ 				op->opresulttype = INT8OID;
+ 				op->opretset = false;
+ 				op->opcollid = InvalidOid;
+ 				op->inputcollid = InvalidOid;
+ 				op->args = list_make2(factor, var);
+ 				op->location = -1;
+ 
+ 				factor = (Expr *) op;
+ 			}
+ 		}
+ 
+ 		/* Construct the function call if needed. */
+ 		if (factor != NULL)
+ 		{
+ 			FuncExpr	*func = makeNode(FuncExpr);
+ 
+ 			func->funcid = aggref->aggtransmultifn;
+ 			func->funcresulttype = aggref->aggtranstype;
+ 			func->funcretset = false;
+ 			func->funcvariadic = false;
+ 			func->funccollid = InvalidOid;
+ 			func->inputcollid = InvalidOid;
+ 			Assert(gvi->var != NULL);
+ 			func->args = list_make2(gvi->var, factor);
+ 			func->location = -1;
+ 
+ 			gvi->expr_intermediate = (Expr *) func;
+ 		}
+ 	}
+ }
+ 
  
  /*****************************************************************************
   *
diff --git a/src/backend/optimizer/plan/planagg.c b/src/backend/optimizer/plan/planagg.c
new file mode 100644
index c3fbf3c..5b3bc71
*** a/src/backend/optimizer/plan/planagg.c
--- b/src/backend/optimizer/plan/planagg.c
*************** preprocess_minmax_aggregates(PlannerInfo
*** 223,229 ****
  			 create_minmaxagg_path(root, grouped_rel,
  								   create_pathtarget(root, tlist),
  								   aggs_list,
! 								   (List *) parse->havingQual));
  }
  
  /*
--- 223,229 ----
  			 create_minmaxagg_path(root, grouped_rel,
  								   create_pathtarget(root, tlist),
  								   aggs_list,
! 								   (List *) parse->havingQual), false);
  }
  
  /*
diff --git a/src/backend/optimizer/plan/planmain.c b/src/backend/optimizer/plan/planmain.c
new file mode 100644
index e880759..c7d98ca
*** a/src/backend/optimizer/plan/planmain.c
--- b/src/backend/optimizer/plan/planmain.c
*************** query_planner(PlannerInfo *root, List *t
*** 83,89 ****
  		add_path(final_rel, (Path *)
  				 create_result_path(root, final_rel,
  									final_rel->reltarget,
! 									(List *) parse->jointree->quals));
  
  		/* Select cheapest path (pretty easy in this case...) */
  		set_cheapest(final_rel);
--- 83,89 ----
  		add_path(final_rel, (Path *)
  				 create_result_path(root, final_rel,
  									final_rel->reltarget,
! 									(List *) parse->jointree->quals), false);
  
  		/* Select cheapest path (pretty easy in this case...) */
  		set_cheapest(final_rel);
*************** query_planner(PlannerInfo *root, List *t
*** 176,181 ****
--- 176,183 ----
  	 */
  	(*qp_callback) (root, qp_extra);
  
+ 	build_base_rel_tlists_grouped(root);
+ 
  	/*
  	 * Examine any "placeholder" expressions generated during subquery pullup.
  	 * Make sure that the Vars they need are marked as needed at the relevant
